/*------------------------------------------------------------------------------
-- This file is a part of the QLop Software
-- Copyright (C) 2015, Plasma Physics Laboratory - CNRS
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
-------------------------------------------------------------------------------*/
/*-- Author : Alexis Jeandet
-- Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#ifndef QLOPSETTINGS_H
#define QLOPSETTINGS_H

#include <QObject>
#include <qlopservice.h>
#include <QSettings>
#include <QDialog>
#include <QIcon>
#include <qlopsettingsdialog.h>


class QLopSettings : public QLopService
{
    Q_OBJECT
    static QDockWidget* m_gui;
    QLopSettings(bool noGUI=false,QObject *parent = 0);
    ~QLopSettings();
    static QLopSettings* _self;
    static QSettings* m_settings;
    static QLopSettingsDialog* m_configDialog;
public:
    QDockWidget* getGUI();
    static void init(bool noGUI=false,QObject *parent = 0);
    const QString& serviceName();
    static QLopSettings* self();
    static void popConfigDialog(QLopSettingsItem *selectedConfigEntry);
    static bool registerConfigEntry(QLopSettingsItem* configEntry,QIcon icon, QString text);
    static void	setValue(QLopService* service,const QString & key, const QVariant & value);
    static QVariant	value(QLopService* service, const QString & key, const QVariant & defaultValue = QVariant());
public slots:
    void popConfigDialog();
};

#endif // QLOPSETTINGS_H
